// 所有事件类型定义
window.g_eventTypes = {
    coreEventType: {
        share : "coreEventType_share", // 分享
        showVideoAd : "coreEventType_showVideoAd", // 视频广告
        showBannerAd : "coreEventType_showBannerAd", // 横幅广告
        hideBannerAd : "coreEventType_hideBannerAd", // 隐藏横幅广告

        vibrate: "coreEventType_vibrate",
        
        launch : "coreEventType_launch",// 游戏启动
        loadStage : "coreEventType_loadStage",// 加载战斗关卡
        loadHall : "coreEventType_loadHall",// 加载大厅
    },

    //加载相关事件
    loadEvent : {
        loadRes : "loadEvent_loadRes",// 请求加载单个资源

        loadResource : "loadEvent_loadResource",// 请求加载资源
        loadComplete : "loadEvent_loadComplete", // 加载资源完毕
        loadProgress : "loadEvent_loadProgress", // 加载进度更新
        
        showFullPanel : "loadEvent_showFullPanel", // 全屏加载界面  长时间的加载
        showLittlePanel : "loadEvent_showLittlePanel", // 透明加载界面  一个短暂的加载
    },

    UIEvent: {
        showUI: "UIEvent_showUI", // 请求打开一个界面
        hideUI: "UIEvent_hideUI",//请求关闭一个界面
        closeAllUI: "UIEvent_closeAllUI", //请求关闭所有界面
        showTips: "UIEvent_UIEvent.showTips",// 显示一个提示
        UIOpened: "UIEvent_UIOpened",
        UIClosed: "UIEvent_UIClosed",
        swallowTouch: "UIEvent_swallowTouch",
        cancelSwallow: "UIEvent_cancelSwallow",
        gamePanelOpened: "UIEvent_gamePanelOpened"
    },

    // 登录
    loginEvent: {
        loginRequest: "loginEvent_loginRequest",
        wxLoginSuccess: "loginEvent_wxLoginSuccess",
        wxLoginFailed: "loginEvent_wxLoginFailed",
        loginSuccess: "loginEvent_loginSuccess",
        loginFailed: "loginEvent_loginFailed",
        checkAuthorize: "loginEvent_checkAuthorize",// 检查用户授权
        destroyUserInfoButton: "loginEvent_destroyUserInfoButton",// 销毁用户授权按钮
        authorized: "loginEvent_authorized",// 授权成功
        authorizeDenied: "loginEvent_authorizeDenied"// 用户拒绝授权
    },
    stageEvent: {
        loadNextStage : "coreEventType_loadNextStage",// 加载下一关
        reloadCurStage : "coreEventType_reloadCurStage",// 重新加载当前关卡
        exitStage : "coreEventType_exitStage",// 退出
        reviveCurStage: "stageEvent_reviveCurStage",
        addStep: "stageEvent_addStep",
        shakeStage: "stageEvent_shakeStage",
        useItem: "stageEvent_useItem",
        itemUsed: "stageEvent_itemUsed",
        stageStart: "stageEvent_stageStart",
        gameStart: "stageEvent_gameStart",
        gamePass: "stageEvent_gamePass",
        levelFirstPass: "stageEvent_levelFirstPass",
        gameFailed: "stageEvent_gameFailed",
        scoreUpdate: "stageEvent_scoreUpdate",
        quitLevel: "stageEvent_quitLevel",
        failReplay: "stageEvent_failReplay",
        failBack: "stageEvent_failBack",
        bonusAniComplete: "stageEvent_bonusAniComplete",
        stepUpdate: "stageEvent_stepUpdate",
        collectionUpdate: "stageEvent_collectionUpdate",
        playEffect: "stageEvent_playEffect",
        goodOperation: "stageEvent_goodOperation",
        perfectOperation: "stageEvent_perfectOperation",
        amazingOperation: "stageEvent_amazingOperation"
    },

    playerEvent: {
        diamondUpdate: "playerEvent_diamondUpdate",
        energyUpdate: "playerEvent_energyUpdate",
        propUpdate: "playerEvent_propUpdate",
        disappearModeUpdate: "playerEvent_disappearModeUpdate",
        wheelTimeUpdate: "playerEvent_wheelTimeUpdate",
        wheelStateUpdate: "playerEvent_wheelStateUpdate",
        newPuzzle: "playerEvent_newPuzzle",
        watchAdTimesUpdate: "playerEvent_watchAdTimesUpdate",
        shareTimesUpdate: "playerEvent_shareTimesUpdate",
        daySignUpdate: "playerEvent_daySignUpdate",
        videoTotalTimesUpdate: "playerEvent_videoTotalTimesUpdate",
        shareTotalTimesUpdate: "playerEvent_shareTotalTimesUpdate",
        dayRewardRedPointUpdate: "playerEvent_dayRewardRedPointUpdate",
        starRewardRedPointUpdate: "playerEvent_starRewardRedPointUpdate",
        avatarUrlUpdate: "playerEvent_avatarUrlUpdate"
    },

    guideEvent: {
        finishCurStep : "guideEvent_finishCurStep", // 完成当前导航步骤
        curStepFinished : "guideEvent_curStepFinished", // 当前导航步骤已完成
        skipGuide : "guideEvent_skipGuide", // 跳过新手引导
        guideSkiped: "guideEvent_guideSkiped"
    },
};