// 界面基类

var Panel = function (rootNode,resourceUrl) {
    this.node = rootNode //面板根节点
    this.bShowing = false // 面板是否打开
    this.resourceUrl = resourceUrl // 资源面板路径
}

Panel.prototype = {
    constructor: Panel,

    getRootNode()
    {
        return this.node
    },
    getResourceUrl()
    {
        return this.resourceUrl
    },

    // 打开面板
    show (...data)
    {
        if(this.bShowing)
        {
            cc.warn("面板已经打开" + this.getResourceUrl())
            return
        }
        G.uiMgr.add(this)
        this.bShowing = true
        
        this.playOpenAni()

        this.onShow(...data)
    },
    // 关闭面板  不要直接调用onHide() onhide是方便子类重写
    hide()
    {
        if(this.bShowing == false)
        {
            return
        }
        this.bShowing = false
        this.onHide()
        G.uiMgr.remove(this)
    },
    // 销毁
    destroy()
    {
        this.onDestroy()
    },

    playOpenAni () {
        var animation = this.node.getComponent(cc.Animation);
        if (animation) {
          animation.play("common_scale");
          G.soundMgr.playEffect(g_resource.openUIAudio);
        }
    },

    // 方便继承后重写
    // 界面打开时会被调用
    onShow(data){},
    // 界面关闭时会被调用
    onHide(){},
    // 重新恢复到最上层
    reShow(){},
    // 被新的界面盖住了
    onCover(){},
    // 销毁  重载
    onDestroy(){},

    playCommonOpenAni () {
        this._view.scaleX = 0;
        this._view.scaleY = 0;
        this._view.opacity = 0;
        this._mask.opacity = 0;
        let actFd = new cc.fadeTo(0.2, this._maskOriginOpactity);
        this._mask.runAction(actFd);

        let actSc = new cc.scaleTo(0.1, 0.8*this._originScaleX, 1.05*this._originScaleY);
        let actFdView = new cc.fadeTo(0.1, 255);
        let spw = new cc.spawn(actSc, actFdView);

        let actSc1 = new cc.scaleTo(0.04, 0.9*this._originScaleX, 1.15*this._originScaleY);
        let actSc2 = new cc.scaleTo(0.06, 1*this._originScaleX, 1*this._originScaleY);
        let actSc3 = new cc.scaleTo(0.06, 1.06*this._originScaleX, 0.95*this._originScaleY);
        let actSc4 = new cc.scaleTo(0.08, 1*this._originScaleX, 1*this._originScaleY);
        let dey = new cc.delayTime(0.05);
        let sceCf = new cc.callFunc(function () {
            if (callback) {
                callback();
            }
        }.bind(this));
        let seq = new cc.sequence(spw, actSc1, actSc2,actSc3, actSc4, dey, sceCf);
        this._view.runAction(seq);
    }
}

module.exports = Panel;