var Panel = require("Panel");

var MainPanel = function MainPanel(rootNode, resourceUrl) {
    Panel.call(this, rootNode, resourceUrl);
    this.binder = this.node.getComponent("MainPanelBinder");

    this.binder.quickStartBtn.on("click", this.quickStart, this);

    if (g_config.isFringeScreen) {
        var widget = this.node.getChildByName("top").getComponent(cc.Widget);
        widget.isAbsoluteTop = false;
        widget.top = .05;
    }
};
MainPanel.prototype = Object.create(Panel.prototype);
MainPanel.prototype.constructor = MainPanel;

MainPanel.prototype.onShow = function(bFirst) {
    this.gameClubButton && this.gameClubButton.show();
    G.eventCenter.on(g_eventTypes.playerEvent.diamondUpdate, this.onDiamondUpdate, this);
    G.soundMgr.playMusic(g_resource.hallBgMusic);
    this.binder.diamondNumLb.string = G.userInfo.getDiamond();
    this.binder.newestLevelLb.string = G.userInfo.getNewestLevel();
};
MainPanel.prototype.onHide = function() {
    this.gameClubButton && this.gameClubButton.hide();
    G.eventCenter.off(g_eventTypes.playerEvent.diamondUpdate, this.onDiamondUpdate, this);
};
MainPanel.prototype.reShow = function() {
    this.gameClubButton && this.gameClubButton.show();
};
MainPanel.prototype.onCover = function() {
    this.gameClubButton && this.gameClubButton.hide();
};
MainPanel.prototype.clickStart = function() {
    G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showUI, g_resource.jewelBlastLevelPanel);
};

MainPanel.prototype.onDiamondUpdate = function(diamond) {
    this.binder.diamondNumLb.string = diamond;
};
MainPanel.prototype.clickRank = function() {
    G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showUI, g_resource.rankPanel);
};
MainPanel.prototype.clickSetting = function() {
    G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showUI, g_resource.settingPanel);
};
MainPanel.prototype.quickStart = function() {
    var energy = G.userInfo.getEnergy();
    if (energy <= 0) {
    G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips, g_string.energyNotenough);
    G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showUI, g_resource.shopPanel);
    return;
    }
    var newestLevel = G.userInfo.getNewestLevel();
    console.log("newestLevel", newestLevel);
    var model = G.tableProvider.getData(g_resource.newLevelTable, newestLevel);
    if (!model) {
    G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips, g_string.passGame);
    return;
    }
    this.binder.energyAni.node.active = true;
    var animState = this.binder.energyAni.play();
    this.binder.scheduleOnce(function() {
    G.userInfo.updateEnergy(-1);
    G.eventCenter.dispatchEvent(g_eventTypes.coreEventType.loadStage, StageType.jewelBlast, newestLevel);
    }.bind(this), animState.duration);
};

MainPanel.prototype.share = function() {
    G.eventCenter.dispatchEvent(g_eventTypes.coreEventType.share, null, true);
};

module.exports = MainPanel;