// 全屏加载界面

cc.Class({
    extends: cc.Component,

    properties: {
        progressBar : cc.ProgressBar,
        rootNode : cc.Node,
    },

    onLoad () {
        this.rootNode.active = false;
        G.eventCenter.on(g_eventTypes.loadEvent.showFullPanel, this.show, this);
    },

    show() {
        if (this.rootNode.active) return cc.warn("loadingpanel reshowed")

        this.rootNode.active = true;
        this.progressBar.node.active = true;
        this.progressBar.progress = 0;

        G.eventCenter.on(g_eventTypes.loadEvent.loadProgress, this.onProgressUpdate, this);
        G.eventCenter.on(g_eventTypes.loadEvent.loadComplete, this.hide, this);
    },

    hide() {
        this.rootNode.active = false;

        G.eventCenter.off(g_eventTypes.loadEvent.loadProgress, this.onProgressUpdate, this);
        G.eventCenter.off(g_eventTypes.loadEvent.loadComplete, this.hide, this);
    },

    onProgressUpdate(progress) {
        this.progressBar.progress = progress;
    },
})