// 
var EventCenter     = require("EventCenter");
var Timer           = require("Timer");

var TableProvider   = require("TableProvider");
var SoundManager    = require("SoundManager");
var UIManager       = require("UIManager");
var ResourceLoader  = require("ResourceLoader");
var StageManager    = require("StageManager");
// var net             = require("NetManager")

var Player          = require("Player");
var GuideManager    = require("GuideManager");
var Login           = require("Login");
var AdManager       = require("AdManager");


var GameRoot = function () {
    this.bRunning   = false;
    window.G        = this;

    this.timer          = new Timer();
    this.eventCenter    = new EventCenter();

    this.resourceLoader = new ResourceLoader();
    this.tableProvider  = new TableProvider();
    this.soundMgr       = new SoundManager();
    this.uiMgr          = new UIManager();
    this.stageMgr       = new StageManager();

    this.userInfo       = new Player();

    this.registerMoudles();
};

GameRoot.prototype = {
    constructor: GameRoot,

    registerMoudles: function () {
        this.login = new Login();
        this.adMgr = new AdManager();
        this.guideMgr = new GuideManager();
    },

    startUp: function () {
        this.bRunning = true;
        G.eventCenter.on(g_eventTypes.coreEventType.loadHall, this.loadHall, this);
        G.eventCenter.dispatchEvent(g_eventTypes.coreEventType.launch);
        G.eventCenter.dispatchEvent(g_eventTypes.loginEvent.loginRequest);
        G.tableProvider.loadAllTables(this.onConfigLoaded, this);
    },

    onConfigLoaded: function () {
        this.userInfo.loadData();
        // this.guideMgr.startGuide();

        G.eventCenter.dispatchEvent(g_eventTypes.coreEventType.loadStage)
        // this.loadHall()
    },

    update: function (dt) {
        dt > .1 && (dt = .03);
        if (this.bRunning) {
            this.timer.tick(dt)
            this.stageMgr.update(dt)
        }
    },

    loadHall: function (bFirst) {
        var data = {};
        data.url = g_resource.mainPanel;
        data.loadPanelType = LoadPanelType.fullPanel;
        data.target = this;
        data.callback = function() {
            G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showUI, g_resource.mainPanel, bFirst);
        };
        G.eventCenter.dispatchEvent(g_eventTypes.loadEvent.loadResource, data);
        this.bFirst = false;
    },
};

module.exports = GameRoot;