// 声音管理器
var SoundManager = function () {
    this.bMute = false
    this.bgMusicAudioID = null
    this.bgMusic = null

    this.lastPlayTime = {}
}
   
SoundManager.prototype = {
    constructor: SoundManager,
    // 静音
    mute() {
        if (!this.bMute) {
            this.bMute = true
            if (this.bgMusicAudioID != null) {
                cc.audioEngine.setVolume(this.bgMusicAudioID,0);
            }
        }
    },

    // 恢复声音
    unmute() {
        if (this.bMute) {
            this.bMute = false
            if (this.bgMusicAudioID != null) {
                cc.audioEngine.setVolume(this.bgMusicAudioID,1);
            }
        } 
    },

    // 播放背景音乐  背景音乐只有一个并且循环播放
    playMusic: function (bgMusicPath) {
        if (this.bgMusic != bgMusicPath) {
            if (this.bgMusicAudioID != null)// 停掉之前的背景音乐
            {
                cc.audioEngine.stop(this.bgMusicAudioID);
                this.bgMusicAudioID = null
            }

            this.bgMusic = bgMusicPath

            let audioClip = ResourceLoader.getInstance().getAsset(bgMusicPath)
            if (audioClip) {
                this.bgMusicAudioID = cc.audioEngine.play(audioClip,true,1)
                if (this.bMute) {
                    cc.audioEngine.setVolume(this.bgMusicAudioID,0);
                }
            } else {
                let self = this
                G.resourceLoader.loadRes(bgMusicPath, cc.AudioClip, function(err, clip) {
                    if (!err) {
                        self.bgMusicAudioID = cc.audioEngine.play(clip, true, 1);
                        if (self.bMute) {
                            cc.audioEngine.setVolume(self.bgMusicAudioID,0);
                        }
                    }
                });
            }
        }
    },
    
    // 播放音效  短促不循环
    playEffect(filePath, delay) {
        if(this.bMute)return

        if (delay && delay > 0) {
            return G.timer.scheduleOnce(this, function() {
                this.playEffect(filePath)
            }, delay)
        }

        let lastFrame = this.lastPlayTime[filePath]
        let curFrame = cc.director.getTotalFrames()
        if (lastFrame && lastFrame >= curFrame) return
        this.lastPlayTime[filePath] = curFrame + 12

        let audioClip = G.resourceLoader.getAsset(filePath)
        if (audioClip) {
            cc.audioEngine.play(audioClip, false, 1)
            var time = cc.audioEngine.getDuration(audioID);
            this.lastPlayTime[filePath] = curFrame + time / 30;
        } else {
            G.resourceLoader.loadRes(filePath, cc.AudioClip, (err, clip) => {
                if (!err) cc.audioEngine.play(clip, false, 1)
            })
        }
    },
};
module.exports = SoundManager;