// 关卡管理器

var StageManager = function StageManager() {
    this.classMap = {};
    this.curStage = null;

    this.registeStages();

    G.eventCenter.on(g_eventTypes.coreEventType.loadStage, this.loadStage, this);
    G.eventCenter.on(g_eventTypes.stageEvent.exitStage, this.exitStage, this);
};

var StageType = {
    normal: 0,
};
window.StageType = StageType

StageManager.prototype = {
    constructor: StageManager,

    // 注册不同场景 关卡
    registeStages()
    {
        this.classMap[StageType.normal] = require("NormalStage")
    },

    // 
    loadStage(stageType, ...obj)
    {
        G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.closeAllUI);

        stageType = StageType.normal
        let stageClass = this.classMap[stageType]
        this.curStage = new stageClass(...obj)
        this.curStage.preload()
    },

    exitStage() {
        if (this.curStage) {
            G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.closeAllUI);

            this.curStage.destroy()
            this.curStage = null

            G.eventCenter.dispatchEvent(g_eventTypes.coreEventType.loadHall);
        }
    },

    getCurStage() {
        return this.curStage
    },

    isInFight () {
        return !!this.curStage;
    },

    update(dt) {
        if (this.curStage) this.curStage.update(dt)
    }
};
module.exports = StageManager;