// 定时器

var Timer = function () {
    this.timers = []
    this.invalidTimers = [] // 无效 待重复利用
}

Timer.prototype = {
    constructor: Timer,

    // 启动计时器
    scheduleOnce (target, callback, interval) {
        this.schedule(target, callback, interval, 1);
    },

    schedule (target,callback,interval,repeatTimes)
    {
        var timer = this.getEntry()
        if (timer) {
            timer._interval = interval;
            cc.warn("计时器重复了")
        } else {
            timer = this.invalidTimers.pop();
            if (!timer) {
                timer = {};
                this.timers.push(timer);
            }
            timer.invalid = false;
            timer._interval = interval;
            timer._elapsed = 0;
            timer._target = target;
            timer._callback = callback;
            timer._timesExecuted = 0;
            if (repeatTimes) {
                timer._repeat = repeatTimes;
                timer._runForever = false;
            } else {
                timer._runForever = true;
                timer._repeat = 99999;
            }
        }
    },

    // 取消计时器
    unschedule(target, callback) {
        var timer = this.getEntry(target, callback);
        if (timer) {
            timer.invalid = true;
            timer._target = null;
            timer._callback = null;
            this.invalidTimers.push(timer);
        }
    },

    // 取消所有
    unscheduleAll()
    {
        this.timers = [];//
        this.invalidTimers = [];//无效的
    },

    tick: function (dt) {
        for (var i = this.timers.length - 1; i >= 0; --i) {
            var timer = this.timers[i];
            if (!timer.invalid) {
                timer._elapsed += dt;
                if (timer._elapsed >= timer._interval) {
                    var elapsed = timer._elapsed;
                    timer._elapsed = 0;
                    ++timer._timesExecuted;

                    timer._target ? timer._callback.call(timer._target, elapsed) : timer._callback(elapsed);

                    if (!timer.invalid && !timer._runForever && timer._timesExecuted >= timer._repeat) {
                        timer.invalid = true;
                        timer._target = null;
                        timer._callback = null;
                        this.invalidTimers.push(timer);
                    }
                }
            }
        }
    },

    // 获取有效的entry
    getEntry(target,callback) {
        for (var k in this.timers) {
            var timer = this.timers[k];
            if (!timer.invalid && timer._target == target && timer._callback == callback) return timer;
        }
        return null;
    }
};
module.exports = Timer;