// 节点缓存池
var NodePool = function () {
    this.poolMap = {};
}

NodePool.prototype = {
    constructor: NodePool,

    get (url) {
        var nodePool = this.poolMap[url];
        if (!nodePool) {
            nodePool = []
            this.poolMap[url] = nodePool
        }

        var node = nodePool.pop();
        if(!node){// 没有缓存直接实例化
          var prefab = G.resourceLoader.getAsset(url);
            if(!prefab)
            {
                cc.error("请预加载" + url)
                return
            }
            node = cc.instantiate(prefab);
            node.urlTag = url// 做一个标记
        }
        node.active = true
        return node;
    },

    put (node) {
        var nodePool = this.poolMap[node.urlTag];
        if (!nodePool) {
            nodePool = []
            this.poolMap[node.urlTag] = nodePool
        }

        nodePool.push(node);
        node.stopAllActions();
        node.active = false;
    },

    // 创建缓存多个实例
    makePool(url,num,parent) {
        if(!num) num = 1
        var prefab = G.resourceLoader.getAsset(url);
        if(!prefab)
        {
            cc.error("请预加载" + url)
            return
        }
        var nodePool = this.poolMap[url];
        if(!nodePool)
        {
            nodePool = []
            this.poolMap[url] = nodePool
        }

        for(let j = 0; j < num; ++j)
        {
            let node = cc.instantiate(prefab);
            node.urlTag = url// 做一个标记
            if(parent)node.parent = parent
            nodePool.push(node);
            node.active = false
        }
    },

    destroy() {
        for(let url in this.poolMap)
        {
            var nodePool = this.poolMap[url]
            for(let k in nodePool)
            {
                let node = nodePool[k]
                node.destroy()
            }
        }
        this.poolMap = {}
        // delete this.poolMap
    },
}

module.exports = NodePool;