
var AdManager = function AdManager() {
  this.bannerAd = null;
  this.adIgnoreMap = {};
  this.lastBannerTime = null;
  this.videoAd = null;
  this.videoObject = null;
  
  this.lastVibrateTime = cc.director.getTotalFrames();

  G.eventCenter.on(g_eventTypes.coreEventType.share, this.share, this);
  G.eventCenter.on(g_eventTypes.coreEventType.showVideoAd, this.showVideoAd, this);
  G.eventCenter.on(g_eventTypes.coreEventType.showBannerAd, this.showBannerAd, this);
  G.eventCenter.on(g_eventTypes.coreEventType.hideBannerAd, this.hideBannerAd, this);
  G.eventCenter.on(g_eventTypes.UIEvent.UIOpened, this.onUIOpened, this);
  G.eventCenter.on(g_eventTypes.coreEventType.UIClosed, this.onUIClosed, this);
  this.adIgnoreMap[g_resource.mainPanel] = true;
  this.adIgnoreMap[g_resource.jewelBlastGamePanel] = true;
  this.adIgnoreMap[g_resource.levelTargetPanel] = true;

  this.init();
  this.checkUpdate();
};

AdManager.prototype = {
  constructor: AdManager,

  init() {
  },
  
  checkUpdate  () {
  },
  
  share(object, noTips)
  {
      if(CC_WECHATGAME)
      {
          let self = this
          let onGameShow = function()
          {
              cc.game.off(cc.game.EVENT_SHOW, onGameShow);
              let now = new Date()
              let diff = now.getTime() - self.shareStartTime.getTime()
              if(diff >= 2500)
              {
                  if(object && object.success)object.success()
                  cc.log("share success:" + diff)
                  if(!noTips)G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,g_string.shareSuccess);
              }else
              {
                  if(object && object.fail)object.fail()
                  if(!noTips)G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,g_string.shareFailed);
              }
          }
          this.shareStartTime = new Date()
          cc.game.on(cc.game.EVENT_SHOW, onGameShow);
          
          let num = Tool.GetRandomInt(1, g_config.shareNum)
          wx.shareAppMessage({
              title: g_string['shareTitle' + num],
              // imageUrl: 'share/' + num + '.jpg',
              imageUrl: 'https://d.988wan.com/dxlx/zjqe/wechatgame/share/' + num + '.jpg',
              query : 'inviterUid=' + G.getMyUserInfo().getUid()
          })
      }else
      {
          if(object && object.success)object.success()
          if(!noTips)G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,g_string.shareSuccess);
      }
  },
  //显示视频广告
  showVideoAd(object)
  {
      if(this.videoObject)return
      
      this.videoObject = object

      let self = this
      if (CC_WECHATGAME) {
          if(!this.videoAd)
          {
              this.videoAd = wx.createRewardedVideoAd({
                  adUnitId: 'adunit-3809fdf813da129f'
              });
              this.videoAd.onClose(res => {
                  cc.audioEngine.resumeAll()
                  // 用户点击了【关闭广告】按钮
                  // 小于 2.1.0 的基础库版本，res 是一个 undefined
                  if (res && res.isEnded || res === undefined) {
                      // 正常播放结束，可以下发游戏奖励
                      if(self.videoObject && self.videoObject.success)
                      {
                          self.videoObject.success()
                      }
                  }else {
                      // 播放中途退出，不下发游戏奖励
                      if(self.videoObject && self.videoObject.fail)self.videoObject.fail()
                      G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,g_string.videoUnfinished);
                  }
                  self.videoObject = null
              });
              
              this.videoAd.onError(res => {
                  if(self.videoObject && self.videoObject.fail)self.videoObject.fail()
                  console.log("videoAd onError",res)

                  let errCode = res.errCode
                  let tips = res.errMsg
                  switch(errCode)
                  {
                      case 0:
                      case 1004:{
                          tips= g_string.noAd;
                          G.getMyUserInfo().videoLimit()
                      }break
                      case 1008: tips= g_string.adUnitClosed;break;
                      default : break;
                  }
                  G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,tips);
                  self.videoObject = null
              });
          }

          try {
              console.log("videoAd before load")
              this.videoAd.load().then(() => self.videoAd.show());
              cc.audioEngine.pauseAll()
              console.log("videoAd after show")
          } catch (e) {
              console.log("videoAd catch exception")
              if(self.videoObject && self.videoObject.fail)self.videoObject.fail()
              G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,g_string.noVideoAd);
              self.videoObject = null
          }
      } else {
          if(object && object.success)object.success()
          G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,g_string.watchAdSuccess);
          self.videoObject = null
      }
  },

  showBannerAd(posInfo)
    {
        if (!CC_WECHATGAME) return
        if(!wx.createBannerAd)return

        if(this.bannerAd)// 强制每次创建一个新的广告
        {
            this.bannerAd.destroy()
            this.bannerAd = null
        }


        let sysInfo = wx.getSystemInfoSync();
        if(!this.bannerAd)
        {
            //初始化广告banner
            this.bannerAd = wx.createBannerAd({
                adUnitId: 'adunit-e2868fbff73ee9fa',
                style: {
                    left: 0,
                    top: sysInfo.windowHeight - 100,
                    // height: 30,
                    width: 300
                }
            });
            this.bannerAd.onResize( (res => {
                this.bannerAd.style.left = (sysInfo.windowWidth - res.width)/2;
                this.bannerAd.style.top = sysInfo.windowHeight - res.height;
                if(!this.bResized)
                {
                    this.bResized = true
                    if(posInfo)
                    {
                        G.timer.scheduleOnce(this, ()=>{
                            let ratio = cc.view._devicePixelRatio
                            let scale = cc.view.getScaleX()
                            let factor = scale / ratio

                            let adWHRatio = this.bannerAd.style.realWidth / this.bannerAd.style.realHeight
                            let height = posInfo.height * factor
                            if(posInfo.width / posInfo.height < adWHRatio)
                            {
                                height = posInfo.width / adWHRatio * factor 
                            }
                            let width = height * adWHRatio
                            
                            this.bannerAd.style.width = width
                            this.bannerAd.style.top = sysInfo.windowHeight - height
                            console.log("style.width:",width)
                            console.log(this.bannerAd.style)
                        },0)
                    }
                }
            }).bind(this) );
            this.bannerAd.onError(res => {
                G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showTips,g_string.adFailed);
            });
        }

        if(this.bannerAd)
        {
            this.bannerAd.show()
        }
  },
  hideBannerAd()
  {
      if(this.bannerAd)this.bannerAd.hide()
  },

  vibrate (bLong) {
    var bOn = G.userInfo.isVibrateOn();
    if (!bOn) return;
    var curFrame = cc.director.getTotalFrames();
    if (this.lastVibrateTime >= curFrame) return;
    this.lastVibrateTime = curFrame;
    false;
    if (cc.sys.isBrowser && cc.sys.isMobile && window.navigator) {
      navigator.vibrate = navigator.vibrate || navigator.webkitVibrate || navigator.mozVibrate || navigator.msVibrate;
      navigator.vibrate && navigator.vibrate(15);
    }
  },

  onUIOpened (url) {
    if (this.adIgnoreMap[url]) return;
    this.showBannerAd();
  },
  onUIClosed  (url) {
    var topUI = G.uiMgr.getTopUI();
    if (topUI) {
      var topUrl = topUI.getResourceUrl();
      this.adIgnoreMap[topUrl] && this.hideBannerAd();
    }
  }
};
module.exports = AdManager;