// 新手引导

var GuideManager = function GuideManager() {
    this.guideID = 0;
    this.curGuideModel = null;
    this.bGuiding = false;
    if (cc.sys.isNative) return;
    var guideID = localStorage.getItem("guideID");
    this.guideID = guideID ? parseInt(guideID) : 1;
    G.eventCenter.on(g_eventTypes.guideEvent.finishCurStep, this.finishCurStep, this);
    G.eventCenter.on(g_eventTypes.guideEvent.skipGuide, this.skipGuide, this);
};
GuideManager._instance = null;
GuideManager.getInstance = function() {
    GuideManager._instance || (GuideManager._instance = new GuideManager());
    return GuideManager._instance;
};
GuideManager.prototype = {
    constructor: GuideManager,
    startGuide: function startGuide() {
    this.curGuideModel = G.tableProvider.getData(g_resource.guideTable, this.guideID);
    if (!this.curGuideModel) return cc.log("no guide");
    this.bGuiding = true;
    var startEvent = this.curGuideModel.TiggerEvent;
    startEvent ? G.eventCenter.on(startEvent, this.onStarTrigger, this) : this.showGuideUI();
    },
    finishCurStep: function finishCurStep(bSkip) {
    var startEvent = this.curGuideModel.TiggerEvent;
    startEvent && G.eventCenter.off(startEvent, this.onStarTrigger, this);
    bSkip || G.eventCenter.dispatchEvent(g_eventTypes.guideEvent.curStepFinished, this.guideID);
    this.guideID++;
    var keyPoint = this.curGuideModel.KeyPoint;
    keyPoint || (keyPoint = this.guideID);
    var guideID = localStorage.getItem("guideID");
    if (guideID) {
        guideID = parseInt(guideID);
        keyPoint > guideID && localStorage.setItem("guideID", keyPoint);
    } else localStorage.setItem("guideID", keyPoint);
    this.curGuideModel = G.tableProvider.getData(g_resource.guideTable, this.guideID);
    if (this.curGuideModel) G.timer.scheduleOnce(this, this.startGuide, 0); else {
        this.bGuiding = false;
        cc.log("\u5bfc\u822a\u7ed3\u675f");
    }
    },
    checkCondition: function checkCondition() {
    var stage = G.stageManager.getCurStage();
    if (!stage) return false;
    if (!this.curGuideModel) return false;
    var level = stage.getLevel();
    if (level == this.curGuideModel.Level) return true;
    return false;
    },
    onStarTrigger: function onStarTrigger() {
    this.checkCondition() && this.showGuideUI();
    },
    showGuideUI: function showGuideUI() {
    G.eventCenter.dispatchEvent(g_eventTypes.UIEvent.showUI, g_resource.guidePanel, this.curGuideModel);
    },
    skipGuide: function skipGuide() {
    cc.log("\u8df3\u8fc7\u5f15\u5bfc");
    this.finishCurStep(true);
    G.eventCenter.dispatchEvent(g_eventTypes.guideEvent.guideSkiped, this.guideID - 1);
    },
    curGuideID: function curGuideID() {
    return this.guideID;
    },
    isGuiding: function isGuiding() {
    return this.bGuiding;
    }
};
module.exports = GuideManager;