var Player = function () {
    this.openid = null;
    this.name = "o.o";
    this.avatarUrl = null;
    this.uid = 0;
    this.bLogin = false;
    this.diamond = 0;
    this.noVideo = false;
    this.bFirstLoad = false;
    this.bFirstDay = false;
    var firstLoginTime = localStorage.getItem("firstLoginTime");
    if (firstLoginTime) {
        firstLoginTime = new Date(parseInt(firstLoginTime));
        var now = new Date();
        now.toDateString() == firstLoginTime.toDateString() && (this.bFirstDay = true);
    }
    this.bFirstLoad = true;
    this.bFirstDay = true;
    localStorage.setItem("firstLoginTime", new Date().getTime());
};

Player.prototype = {
    constructor: Player,

    isLogin () {
        return this.bLogin;
    },

    getUid() {
        return this.uid;
    },

    isFirstLoad() {
        return this.bFirstLoad;
    },

    isFirstDay() {
        return this.bFirstDay;
    },

    loadData() {
        var diamond = localStorage.getItem("diamond");
        null !== diamond && void 0 !== diamond && "" !== diamond && (this.diamond = parseInt(diamond));

        this.loadDayData();

        var h = new Date().getHours();
        var interval = h > 23 ? 60 : 300;
        G.timer.schedule(this, this.checkNewDay, interval);
    },

    loadDayData() {
        var now = new Date();
        var lastLoginTime = localStorage.getItem("lastLoginTime");
        localStorage.setItem("lastLoginTime", now.getTime());
        if (lastLoginTime) {
            lastLoginTime = new Date(parseInt(lastLoginTime));
            if (now.toDateString() == lastLoginTime.toDateString()) {
            console.log("already logined");
            } else {
            var dayMs = 864e5;
            var beforeDay = Math.ceil(lastLoginTime.getTime() / dayMs);
            var nowDay = Math.ceil(now.getTime() / dayMs);
            var diffDay = nowDay - beforeDay;
            console.log("logined few days ago", lastLoginTime.toDateString(), lastLoginTime.getTime(), beforeDay, now.toDateString(), now.getTime(), nowDay, diffDay);
            localStorage.setItem("noVideo", 0);
            }
        } else console.log("never logined");
    },

    checkNewDay() {
        var lastLoginTime = localStorage.getItem("lastLoginTime");
        if (lastLoginTime) {
            lastLoginTime = new Date(parseInt(lastLoginTime));
            var now = new Date();
            now.toDateString() != lastLoginTime.toDateString() && this.loadDayData();
        }
    },

    getDiamond() {
        return this.diamond;
    },

    updateDiamond(changeValue) {
        this.diamond += changeValue;
        localStorage.setItem("diamond", this.diamond);
        changeValue < 0 && this.updateDiamondCost(-changeValue);
        G.eventCenter.dispatchEvent(g_eventTypes.playerEvent.diamondUpdate, this.diamond, changeValue);
    },

    getNewestLevel: function getNewestLevel() {
        return this.newestLevel;
    },

    updateNewestLevel(level) {
        if (level == this.newestLevel) {
            this.newestLevel++;
            this.addNewPassLevel();
            G.eventCenter.dispatchEvent(g_eventTypes.stageEvent.levelFirstPass, level);
        }
    },

    hasVideo() {
        return !this.noVideo;
    },

    videoLimit() {
        this.noVideo = true;
    },


    setOpenid(openid) {
        this.openid = openid;
        this.bLogin = true;
    },

    getOpenId() {
        return this.openid;
    },

    setWxUserInfo(userinfo) {
        this.name = userinfo.nickName;
        this.avatarUrl = userinfo.avatarUrl;
        G.eventCenter.dispatchEvent(g_eventTypes.playerEvent.avatarUrlUpdate);
    },

    getName() {
        return this.name;
    },

    getAvatarUrl() {
        return this.avatarUrl;
    },
};
module.exports = Player;