// 入口

//实现继承
if (typeof Object.create !== 'function') {
    Object.create = function (obj) {
        function F() {}
        F.prototype = obj;
        return new F();
    };
}

if(!window.localStorage)window.localStorage = cc.sys.localStorage

if(CC_WECHATGAME)
{
    localStorage.setItem = function(key, value) {//fix me
        wx.setStorage({
            key: key,
            data: value
          })
    }
}

// cc.macro.SHOW_MESH_WIREFRAME = true;

let GameRoot = require("GameRoot")

cc.Class({
    extends: cc.Component,
    
    properties: {
        versionLable: cc.Label,
    },

    onLoad () {
        cc.game.on(cc.game.EVENT_HIDE, function () {
            cc.log("cc.game.EVENT_HIDE")
            cc.audioEngine.pauseAll()
        });
        cc.game.on(cc.game.EVENT_SHOW, function () {
            cc.log("cc.game.EVENT_SHOW")
            cc.audioEngine.resumeAll()
        });
        // this.requestDynamicConfig()

        // 适配方案
        let frameSize = cc.view.getFrameSize();
        let bFitWidth = (frameSize.width / frameSize.height) < (1280 / 720)
        cc.Canvas.instance.fitWidth = bFitWidth;
        cc.Canvas.instance.fitHeight = !bFitWidth;

        //刘海屏判断
        g_config.isFringeScreen = false
        if(cc.sys.os == cc.sys.OS_IOS){
            g_config.isFringeScreen = (frameSize.width == 414 && frameSize.height == 896)
                                        ||(frameSize.width == 375 && frameSize.height == 812);
        }else{
            if(frameSize.height / frameSize.width > (16/9))
            {
                g_config.isFringeScreen = true
            }
        }

        // 帧率锁定  锁帧
        // let fps = (cc.sys.os == cc.sys.OS_IOS)? 45 : 45
        // cc.game.setFrameRate(fps);
        // if(CC_WECHATGAME)wx.setPreferredFramesPerSecond(fps)

        // 显示版本号
        this.versionLable.node.on(cc.Node.EventType.TOUCH_START, ()=>{
            this.versionLable.string = g_config.version
            this.scheduleOnce(this.showFPS, 5)
        },this)

        // 每个新的体验版需要清除玩家数据
        if(g_config.isTest && this.checkNewVersion())this.clearUserData()

        new GameRoot().startUp()
    },

    //实时帧率显示
    showFPS() {
        let last = null
        this.schedule(function() {
            let now = cc.director.getTotalFrames()
            if(last)
            {
                this.versionLable.string = now - last
            }
            last = now
        }, 1);
    },

    checkNewVersion() {
        let preVersion = localStorage.getItem('preVersion')
        return !(preVersion && preVersion == g_config.version)
    },
    
    // 清除玩家数据
    clearUserData() {
        if(CC_WECHATGAME)
        {
            console.log('before clear')
            try {
                wx.clearStorageSync()
            } catch (e) {
                wx.clearStorage()
            }
            console.log('after clear')
        }else
        {
            localStorage.clear()
        }
        localStorage.setItem('preVersion', g_config.version)
    },

    requestDynamicConfig()
    {
        let self = this

        let url = "https://d.988wan.com/dxlx/zjqe/wechatgame/dynamicConfig.json"

        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 400)) {
                var config = JSON.parse(xhr.responseText)
                self.setConfig(config)
            }
        };
        xhr.open("GET", url, true);
        xhr.send();
    },
    setConfig(config)
    {
        console.log(config);
        Tool.setAttr(g_string, config.string)
        Tool.setAttr(g_config, config.config)
    },

    update(dt)
    {
        G.update(dt)
    },
});