
var Tool = {

    GetShortStr(str,limit) {
        limit=limit*2;
    
        var endIndex = str.length;
        var curLength=0;
        for(var i=0;i<str.length;++i){
            var code = str.charCodeAt(i);
            if(code <128){
                ++curLength;
            }else{
                curLength+=2;
            }
            if(curLength>limit){
                endIndex=i;
                break;
            }
        }
        return str.slice(0,i);
    },
    //矩形与圆形是否相交 1转换圆心到相对矩形中心点的第一象限
    RectIntersectsCircle(rect,circle){
        var midH = rect.height >> 1
        var midW = rect.width >> 1
        var midX = rect.x + midW
        var midY = rect.y + midH
        var cx = circle.x - midX
        var cy = circle.y - midY
        if(cx < 0)cx = -cx
        if(cy < 0)cy = -cy
        var ax = cx - midW
        var ay = cy - midH
        if(ax < 0) ax = 0
        if(ay < 0) ay = 0
        var radius = circle.radius
        return (ax*ax + ay*ay) <= (radius*radius)
    },
    // 包括max
    GetRandomInt(min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    },

    ArrayEqual(arrayA, arrayB) {
        if(arrayA.length != arrayB.length)return false;

        return arrayA.every(function (elem, index, arr) {
            return elem == arrayB[index];
        });
    },
    FormatTime(time) {
        time = Math.ceil(time);

        var minute = Math.floor(time / 60);
        var second = time % 60;

        if (minute < 10) minute = "0" + minute;
        if (second < 10) second = "0" + second;

        return minute + ":" + second;
    },

    setRemoteImage(headSprite, avatarUrl) {
        if (!avatarUrl || "" == avatarUrl) {
        cc.log("\u65e0\u6548\u7684\u5934\u50cf\u5730\u5740\uff1a" + avatarUrl);
        return;
        }
        var spriteFrame = Tool.spriteFrameChace[avatarUrl];
        spriteFrame ? headSprite.spriteFrame = spriteFrame : cc.loader.load({
        url: avatarUrl,
        type: "jpg"
        }, function(error, texture) {
        if (error) cc.log("load headIcon failed!"); else {
            var sp = new cc.SpriteFrame();
            sp.setTexture(texture);
            headSprite.spriteFrame = sp;
            Tool.spriteFrameChace[avatarUrl] = sp;
        }
        });
    },

    setSprite(sprite, url) {
        cc.loader.loadRes(url, cc.SpriteFrame, function(err, spriteFrame) {
        err ? cc.log("setSprite failed:", url, err) : sprite.spriteFrame = spriteFrame;
        });
    },

    spriteFrameChace: {},
    setSpriteFromCache(sprite, url) {
        var spriteFrame = Tool.spriteFrameChace[url];
        spriteFrame ? sprite.spriteFrame = spriteFrame : cc.loader.loadRes(url, cc.SpriteFrame, function(err, sp) {
        if (err) {
            cc.error(err.message || err);
            return;
        }
        sprite.spriteFrame = sp;
        Tool.spriteFrameChace[url] = sp;
        });
    },

    // 判断两个日期是否为同一周
    isSameWeek(old,now){
        var oneDayTime = 1000*60*60*24;  
        var old_count =parseInt(old.getTime()/oneDayTime);  
        var now_other =parseInt(now.getTime()/oneDayTime);  
        return parseInt((old_count+4)/7) == parseInt((now_other+4)/7);  
    },
    setAttr(obj, properties)
    {
        for(var k in properties)
        {
            obj[k] = properties[k]
        }
    },

    convertToCanvasSpace(node) {
      
    },

    shakeEffect(node, duration) {
      node.stopAllActions();
      node.runAction(cc.repeatForever(cc.sequence(cc.moveTo(.02, cc.v2(5, 7)), cc.moveTo(.02, cc.v2(-6, 7)), cc.moveTo(.02, cc.v2(-13, 3)), cc.moveTo(.02, cc.v2(3, -6)), cc.moveTo(.02, cc.v2(-5, 5)), cc.moveTo(.02, cc.v2(2, -8)), cc.moveTo(.02, cc.v2(-8, -10)), cc.moveTo(.02, cc.v2(3, 10)), cc.moveTo(.02, cc.v2(0, 0)))));
      
      node.runAction(cc.sequence(cc.delayTime(duration), cc.callFunc(function() {
        node.stopAllActions();
        node.setPosition(0, 0);
      })));
    },
    
    nodeBreath(node) {
        if (!node) {
            return;
        }
        if (!node.originScaleX) {
            node.originScaleX = node.scaleX;
            node.originScaleY = node.scaleY;
        }
        if (node.breathAction) {
            node.stopAction(node.breathAction);
        }
        node.scaleX = node.originScaleX;
        node.scaleY = node.originScaleY;
        let sx = node.scaleX;
        let sy = node.scaleY;
        let extra = 0.05;
        let t = 1;
        let sc1 = new cc.scaleTo(t, sx * (1 + extra), (1 + extra) * sy);
        let sc3 = new cc.scaleTo(t, sx, sy);
        let seq = new cc.sequence(sc1, sc3);
        let rep = new cc.repeatForever(seq);
        node.breathAction = node.runAction(rep);
    },
    
    //节点的弹动效果
    bounceNodeWithInterval (node, delayInterval, extraScale, timeInterval) {
        if (!node) {
            return;
        }
        if (!node.originScaleX) {
            node.originScaleX = node.scaleX;
            node.originScaleY = node.scaleY;
        }
        if (node.bounceAction) {
            node.stopAction(node.bounceAction);
        }
        node.scaleX = node.originScaleX;
        node.scaleY = node.originScaleY;
        extraScale = extraScale || 0.2;
        timeInterval = timeInterval || 0.1;
        let sx = node.scaleX;
        let sy = node.scaleY;
        let s3 = new cc.scaleTo(timeInterval, sx * (1 - extraScale), sy * (1 + extraScale));
        let s4 = new cc.scaleTo(timeInterval * 2, sx * (1 + extraScale), sy * (1 - extraScale));
        let s5 = new cc.scaleTo(timeInterval * 3 / 2, sx * (1 - extraScale / 2), sy * (1 + extraScale / 2));
        let s6 = new cc.scaleTo(timeInterval, sx * (1 + extraScale / 2), sy * (1 - extraScale / 2));
        let s7 = new cc.scaleTo(timeInterval / 2, sx * 1, sy * 1);
        let dey = new cc.delayTime(delayInterval || 0);
        let seq = new cc.sequence(dey, s3, s4, s5, s6, s7);
        seq.easing(cc.easeInOut(2));
        let rep = new cc.repeatForever(seq);
        node.bounceAction = node.runAction(rep);
    },
  };
  window.Tool = Tool;
  
  module.exports = Tool;